##
# .test.test_libresource
##
import struct
from .. import libresource

def test_sockets(test):
	test.fail_if_not_equal(list(libresource.sockets(10)), [-1] * 10)
	sb = libresource.sockets(16)
	mv = memoryview(sb)
	test.fail_if_equal(sb[0], 1) # should be -1, but anything aside from 1 is okay.
	# itemsize is 4, so use pack_into.
	struct.pack_into("i", mv, 0, 1)
	test.fail_if_not_equal(sb[0], 1)

def test_octets(test):
	test.fail_if_not_equal(list(libresource.octets(20)), [0] * 20)
	mb = libresource.octets(20)
	mb[0:5] = b'fffff'
	test.fail_if_not_equal(memoryview(mb).tobytes(), b'fffff' + (b'\x00' * (20 - 5)))
	mv = memoryview(mb)
	b = bytes(mv[11])
	mb[10:15] = b'fffff'

if __name__ == '__main__':
	from dev import libtest; libtest.execmodule()
